#!/bin/sh
#Interfaz Xdialog para buscar palabras en la lista de CD's. 
#Necesita los siguientes paquetes:
# glark: para hacer la busqueda
# catdoc: para convertir al vuelo el listado de cds (garraxicds.rtf) del formato rtf al de texto
# gawk: para hacer algunos parseos de texto
# wc (del paquete coreutils): para contar el numero de palabras metidas
# xdialog: para presentar las ventanitas...
#
#Este script est licenciado bajo la [1] GNU General Public License (GPL) y por tanto
# se permite su copia, distribucin y/o modificacin mientras se mantenga su licencia y
# se cite que est realizado por [2] Garraxi Irratia. Contacto: [3] Martintxo
#
#[1] http://www.gnu.org/copyleft/gpl.html
#[2] http://sindominio.net/garraxi/
#[3] martintxo@sindominio.net

#GUI para meter el termino de busqueda:
GUI=`Xdialog --wmclass "buscacd" --title "Buscar CDs" --stdout --separator "|" \
      --check "Que las 2 palabras puedan estar en diferentes CDs? (busca CDs con una u otra palabra)" \
      --inputbox "BUSQUEDA DE CDs:\nIntroduce los trminos para la busqueda de CDs.\nEn la bsqueda no influye que metas maysculas o minsculas.\nSi metes 2 palabras, estarn juntas en el ttulo del mismo CD, a no ser que pinches el botn...\nNO metas mas de 2 palabras." 0 0 ""  `

#Cuando NO se rellena la casilla, sale sin hacer nada (igual si se cancela):
if [ "$GUI" = "" ];then
  exit;
fi

#Quita a $gui el output de --check que aparece despues de un espacio y puede ser checked o unchecked (para que no de errores):
GUI2=`echo $GUI | gawk --source '{ sub (/ checked/, ""); sub (/ unchecked/, ""); sub (/checked/, "");  sub (/unchecked/, ""); print }'`

#Parsea el output de --check para aadir '-o' o el '-a 0' a glark (para que busque las dos palabras por separado):
 for i in $GUI ; do
 	case $i in
 		checked)
 			MODE="-o"
 			;;
 	esac
 done
 for i in $GUI ; do
 	case $i in
 		unchecked)
 			MODE="-a 0"
 			;;
 	esac
 done
 
#Mira a ver si las palabras metidas son 1, 2 o mas:
COUNT=`echo "$GUI2" | wc --words`

#Cuando hay dos palabras busca en garraxicds.txt de las dos formas diferentes de arriba:
if [ "$COUNT" = "2" ];then
    catdoc /home/garraxi/Lista_CD/garraxicds.rtf | glark --grep --no-filename -i $MODE $GUI2 | \
    Xdialog --wmclass "buscacd" --title "Buscar CDs" --no-cancel \
     --backtitle "Resultado de la bsqueda de CDs.\nBscalo en las estanterias por su nmero.\n \nAl darle al OK vuelve a aparecer otra ventana para la bsqueda,\nsi no quieres buscar nada mas, dale a cancelar en esa ventana." --tailbox "-" 20 75;
    exec buscacd.sh;
fi

#Cuando hay 1 palabra busca en garraxicds.txt por solo una palabra:
if [ "$COUNT" = "1" ];then
    catdoc /home/garraxi/Lista_CD/garraxicds.rtf | glark --grep --no-filename -i $GUI2 | \
    Xdialog --wmclass "buscacd" --title "Buscar CDs" --no-cancel \
     --backtitle "Resultado de la bsqueda de CDs.\nBscalo en las estanterias por su nmero.\n \nAl darle al OK vuelve a aparecer otra ventana para la bsqueda,\nsi no quieres buscar nada mas, dale a cancelar en esa ventana." --tailbox "-" 20 75;
    exec buscacd.sh;
fi

#Cuando hay mas de 2 palabras da mensaje de error:
if [ "$COUNT" != "1" ] && [ "$COUNT" != "2" ];then
    Xdialog --wmclass "buscacd" --title "Buscar CDs" --no-cancel --icon /usr/local/share/pixmaps/warning.xpm \
            --msgbox "Has metido mas de 2 palabras en la bsqueda\nIntentalo de nuevo con 1 o 2 palabras solo..." 0 0;
    exec buscacd.sh;
fi
